package.path = package.path .. ";./mnotes-lua/?.lua"
require("mnotes-lua/mnotes")

f2m = {
  
  create_note = function(x, res)
    mnotes.note.update(res.note, x.title .. " - " .. x.link)
    print("New feed for " .. x.title .. ": " .. mnotes.object.get(res.object).id)
  end,
  
  create_notes = function(t, start_epoch)
    t = f2m.filter_old_notes(t, start_epoch)
    if t.images == "distant" then f2m.dl_images(t) end
    for _,x in ipairs(t) do
      local res = mnotes.query.perform(x.image)
      if res.found then
        local must_skip, must_detach = false, false
        for _,n in ipairs(mnotes.object.get(res.object).notes) do
          if n.user == mnotes.key then
            if n.text == x.title .. " - " .. x.link then must_skip = true
            else must_detach = true end
          end
        end
        if must_skip then f2m.skip(x, res)
        elseif must_detach then f2m.detach(x, res)
        else f2m.create_note(x, res) end
      else f2m.create_note(x, res) end
    end
  end,
  
  detach = function(x, res)
    local newres = mnotes.note.detach(res.note)
    local old_oid = mnotes.object.get(res.object).id
    local new_oid = mnotes.object.get(newres.object).id
    local text = x.title .. " - " .. x.link
    mnotes.note.update(res.note, text)
    print("Found " .. x.image .. " (" .. x.title .. ") at " .. old_oid .. ", detached at " .. new_oid)
  end,
  
  dl_images = function(t)
    print("Downloading images...")
    local n = 1
    for _,x in ipairs(t) do
      local iname = "img/" .. n .. ".jpg"
      download(x.image, iname)
      x.image = iname
      n = n+1
    end
    print("Done downloading.")
    return t
  end,
  
  filter_old_notes = function(t, start_epoch)
    r = { images = t.images }
    local se = tonumber(start_epoch)
    if se == nil then se = 0 end
    for _,x in ipairs(t) do
      local update = tonumber(x.update)
      if update == nil or update > se then
        table.insert(r, x)
      end
    end
    return r
  end,
  
  skip = function(x, res)
    local oid = mnotes.object.get(res.object).id
    print("Found " .. x.image .. " (" .. x.title .. ") at " .. oid .. ", skipped.")
  end,
  
}